# Во имя Бога Милостивого, Милосердного!!!
# language: ru
Функциональность: Счёт

  Сценарий: Платёж по ОПС в квартале
    Дано Год: 2024
    Дано Квартал: <квартал>
    То Есть цель: ОПС за этот квартал: 12375

    Примеры:
      | квартал |
      |       1 |
      |       2 |
      |       3 |
      |       4 |

  Сценарий: Платёж 1% сверх 300тр: в год и за 1-ый квартал
    Дано Год: 2024
    Дано Квартал: 1
    Дано Доход: <доход>
    То Есть цель: 1% сверх 300тр за квартал: "<оплатить_за_квартал>"
    То Есть цель: 1% сверх 300тр за год: "<оплатить_за_год>"

    Примеры:
      | доход  | оплатить_за_квартал | оплатить_за_год |
      |      0 |                   0 |               0 |
      | 300000 |                   0 |               0 |
      | 300001 |                   0 |               0 |
      | 300049 |                   0 |               0 |
      | 300050 |                   1 |               1 |
      | 300051 |                   1 |               1 |
      | 300100 |                   1 |               1 |
      | 300200 |                   2 |               2 |
      | 400000 |                1000 |            1000 |
      | 500000 |                2000 |            2000 |

  Сценарий: Платёж 1% сверх 300тр: в год и за все кварталы
    Дано Год: 2024
    Дано Доход <доход1> за 1 квартал
    Дано Доход <доход2> за 2 квартал
    Дано Доход <доход3> за 3 квартал
    Дано Доход <доход4> за 4 квартал
    То Есть цель: 1% сверх 300тр за 1 квартал: "<оплатить1>"
    То Есть цель: 1% сверх 300тр за 2 квартал: "<оплатить2>"
    То Есть цель: 1% сверх 300тр за 3 квартал: "<оплатить3>"
    То Есть цель: 1% сверх 300тр за 4 квартал: "<оплатить4>"
    То Есть цель: 1% сверх 300тр за год: "<оплатить_за_год>"

    Примеры:
      | доход1 | оплатить1 | доход2 | оплатить2 | доход3 | оплатить3 | доход4 | оплатить4 | оплатить_за_год |
      |      0 |         0 |      0 |         0 |      0 |         0 |      0 |         0 |               0 |
      | 100000 |         0 | 100000 |         0 |      0 |         0 |      0 |         0 |               0 |
      | 100000 |         0 | 100000 |         0 | 100000 |         0 |      0 |         0 |               0 |
      |   1000 |         0 |  90000 |         0 | 100000 |         0 | 100000 |         0 |               0 |
      | 100000 |         0 | 250000 |       500 |      0 |         0 |      0 |         0 |             500 |
      | 100000 |         0 | 100000 |         0 | 100000 |         0 | 100000 |      1000 |            1000 |
      | 100000 |         0 | 100000 |         0 | 200000 |      1000 | 100000 |      1000 |            2000 |
      | 100000 |         0 | 250000 |       500 | 400000 |      4000 |      0 |         0 |            4500 |
      | 100000 |         0 | 250000 |       500 | 400000 |      4000 | 500000 |      5000 |            9500 |
      | 400000 |      1000 |      0 |         0 |      0 |         0 |      0 |         0 |            1000 |
      |      0 |         0 | 400000 |      1000 |      0 |         0 |      0 |         0 |            1000 |
      |      0 |         0 |      0 |         0 | 400000 |      1000 |      0 |         0 |            1000 |
      |      0 |         0 |      0 |         0 |      0 |         0 | 400000 |      1000 |            1000 |
      | 400000 |      1000 | 100000 |      1000 |      0 |         0 |      0 |         0 |            2000 |
      | 400000 |      1000 | 500000 |      5000 | 600000 |      6000 | 700000 |      7000 |           19000 |

  Сценарий: Платёж по УСН в квартале: 4%
    Дано Год: 2024
    Дано Квартал: <квартал>
    Дано Доход: 500000
    То Есть цель: УСН за этот квартал: 20000

    Примеры:
      | квартал |
      |       1 |
      |       2 |
      |       3 |
      |       4 |

  Сценарий: Добавление дохода в год и квартал
    Дано Год: 2024
    Дано Квартал: 1
    Дано Доход 100000 за 1 квартал
    Дано Доход 200000 за 1 квартал
    Дано Доход 400000 за 2 квартал
    То Доход в квартал: 300000
    То Доход в год: 700000

  Сценарий: Задаётся номер счёта
    Дано Год: 2024
    Когда Задан счёт "123"
    То Считывается счёт "123"

  Сценарий: Достижение целей: неизвестная - ошибка
    Дано Год: 2024
    Дано Должна быть ошибка
    Когда Действие: "неизвестная" за 1 квартал

  Сценарий: Достижение целей: ОПС
    Дано Год: 2024
    * Цель "ОПС" за 1 квартал достигнута: "-"
    * Цель "1пр" за 1 квартал достигнута: "-"
    * Цель "УСН" за 1 квартал достигнута: "-"
    Когда Действие: "ОПС" за 1 квартал
    То Цель "ОПС" за 1 квартал достигнута: "+"
    То Цель "ОПС" за 2 квартал достигнута: "-"
    То Цель "ОПС" за 3 квартал достигнута: "-"
    То Цель "ОПС" за 4 квартал достигнута: "-"
    То Цель "1пр" за 1 квартал достигнута: "-"
    То Цель "УСН" за 1 квартал достигнута: "-"

  Сценарий: Достижение целей: 1пр сверх 300тр
    Дано Год: 2024
    * Цель "ОПС" за 1 квартал достигнута: "-"
    * Цель "1пр" за 1 квартал достигнута: "-"
    * Цель "УСН" за 1 квартал достигнута: "-"
    Когда Действие: "1пр" за 1 квартал
    То Цель "ОПС" за 1 квартал достигнута: "-"
    То Цель "1пр" за 1 квартал достигнута: "+"
    То Цель "1пр" за 2 квартал достигнута: "-"
    То Цель "1пр" за 3 квартал достигнута: "-"
    То Цель "1пр" за 4 квартал достигнута: "-"
    То Цель "УСН" за 1 квартал достигнута: "-"

  Сценарий: Достижение целей: УСН
    Дано Год: 2024
    * Цель "ОПС" за 1 квартал достигнута: "-"
    * Цель "1пр" за 1 квартал достигнута: "-"
    * Цель "УСН" за 1 квартал достигнута: "-"
    Когда Действие: "УСН" за 1 квартал
    То Цель "ОПС" за 1 квартал достигнута: "-"
    То Цель "1пр" за 1 квартал достигнута: "-"
    То Цель "УСН" за 1 квартал достигнута: "+"
    То Цель "УСН" за 2 квартал достигнута: "-"
    То Цель "УСН" за 3 квартал достигнута: "-"
    То Цель "УСН" за 4 квартал достигнута: "-"
