package schet

import (
	"context"
	"os"
	"testing"

	. "my/schet/pkg/testlib"

	"github.com/cucumber/godog"
	"github.com/cucumber/godog/colors"

	. "github.com/onsi/gomega"
)

func InitializeScenario(ctx *godog.ScenarioContext) {
	ctx.Step(`^Год: (\d+)$`, год)
	ctx.Step(`^Квартал: (\d+)$`, квартал)
	ctx.Step(`^Доход: (\d+)$`, доход)
	ctx.Step(`^Доход (\d+) за (\d+) квартал$`, доходЗаКвартал)
	ctx.Step(`^Доход в квартал: (\d+)$`, доходВКвартал)
	ctx.Step(`^Доход в год: (\d+)$`, доходВГод)
	ctx.Step(`^Есть цель: ОПС за этот квартал: (\d+)$`, естьЦельОПСЗаЭтотКвартал)
	ctx.Step(`^Есть цель: УСН за этот квартал: (\d+)$`, естьЦельУСНЗаЭтотКвартал)
	ctx.Step(`^Есть цель: (\d+)% сверх (\d+)тр за квартал: "([^"]*)"$`, естьЦельСверхТрЗаКвартал)
	ctx.Step(`^Есть цель: (\d+)% сверх (\d+)тр за (\d+) квартал: "([^"]*)"$`, естьЦельСверхТрЗаNКвартал)
	ctx.Step(`^Есть цель: (\d+)% сверх (\d+)тр за год: "([^"]*)"$`, естьЦельСверхТрЗаГод)
	ctx.Step(`^Задан счёт "([^"]*)"$`, заданСчёт)
	ctx.Step(`^Считывается счёт "([^"]*)"$`, считываетсяСчёт)
	ctx.Step(`^Должна быть ошибка$`, должнаБытьОшибка)
	ctx.Step(`^Действие: "([^"]*)" за (\d+) квартал$`, действиеЗаКвартал)
	ctx.Step(`^Цель "([^"]*)" за (\d+) квартал достигнута: "([^"]*)"$`, цельЗаКварталДостигнута)
	// -----------------------
	ctx.Before(func(ctx context.Context, sc *godog.Scenario) (context.Context, error) {
		beforeScenario()
		return ctx, nil
	})
	ctx.After(func(ctx context.Context, sc *godog.Scenario, err error) (context.Context, error) {
		afterScenario()
		return ctx, nil
	})
	InitializeGomegaForGodog(ctx)
	_ = Ω
}

func InitializeSuite(tsc *godog.TestSuiteContext) {
	tsc.BeforeSuite(beforeSuite)
	tsc.AfterSuite(afterSuite)
}

func TestMain(t *testing.T) {
	var opts = godog.Options{
		Output:        colors.Colored(os.Stdout),
		Strict:        true,
		StopOnFailure: true,
		TestingT:      t,
	}

	godog.BindCommandLineFlags("godog.", &opts)
	godog.TestSuite{
		Name:                 "app",
		TestSuiteInitializer: InitializeSuite,
		ScenarioInitializer:  InitializeScenario,
		Options:              &opts,
	}.Run()
}
