package schet

const (
	КоличествоКварталов     = 4
	НомерПервогоКвартала    = 1
	НомерПоследнегоКвартала = 4
)

type Год struct {
	год   int
	цели  *Цели
	доход float64
	счёт  string
	out   OutIface
}

func NewГод(год int) *Год {
	g := &Год{
		год: год,
	}
	g.создатьЦели()
	return g
}

func (g *Год) создатьЦели() {
	c := NewЦели(g)
	for i := 0; i < КоличествоКварталов; i++ {
		c.Кварталы = append(c.Кварталы, NewКвартал(i+1, g))
	}
	g.цели = c
}
func (g *Год) Цели() *Цели {
	return g.цели
}

func (g *Год) Год() int {
	return g.год
}

func (g *Год) ЗадатьСчёт(s string) error {
	g.счёт = s
	return nil
}
func (g *Год) Счёт() string {
	return g.счёт
}

func (g *Год) Сделать(цель string, квартал int) error {
	k, err := g.Квартал(квартал)
	if err != nil {
		return err
	}

	return k.Сделать(цель)
}
func (g *Год) ЦельДостигнута(цель string, квартал int) bool {
	k, err := g.Квартал(квартал)
	if err != nil {
		return false
	}

	return k.ЦельДостигнута(цель)
}

func (g *Год) Квартал(in int) (k *Квартал, e error) {
	return g.цели.Квартал(in)
}

func (g *Год) ДобавитьДоход(доход float64, i int) error {
	k, err := g.Квартал(i)
	if err != nil {
		return err
	}

	g.доход += доход

	return k.ДобавитьДоход(доход)
}
func (g *Год) Доход() float64 {
	return g.доход
}

func (g *Год) ПроцентСверх300тр() (float64, error) {
	return ПроцентСверх300тр(g.доход), nil
}

func (g *Год) Сверх300трвКвартале(квартал int) (float64, error) {
	сумматор := NewСумматор300тр()
	for i := НомерПервогоКвартала; i <= квартал; i++ {
		k, err := g.Квартал(i)
		if err != nil {
			return 0, err
		}
		сумматор.ДобавитьКвартал(k.доход)
	}

	return сумматор.Квартал(квартал)
}

func (g *Год) Вывести(out OutIface) error {
	g.out = out
	return out.Печать(g)
}
